## Name : fur_en.rb
## Description : Make Fur( Grass )
## Auther : TAK2HATA ( http://onigiriburning.so.land.to/ )
##Since : 2010-04-21--- v0.0
##Rev : 2010-05-05-- v0.1
##	speedup
##	add component     --
##  add menu for mac  -- v0.3
##Rev : 2010-05-06   -- v1.0
##  Because I did a big change, this plugin might have the problem.
##  use to be carefully. Especially, about saving file.
##  menu named "Fur!(MAC)" change to "Fur v1_0!(InputBox)"
##  menu named "Fur!(EN)" change to "Fur v1_0!(WebDialog)"
##  Type select to Name
##  fix problem:when length too small,it create also 50.mm
##  add Type for Box option
##  add fur model from Select Component option
##  Change Extra Upper force strength
##  add keep fur parameter.
##  add save & load preset.
##  How to save preset
##    Webdialog::Press "Save New Preset" button, and input preset name.
##    InputBox ::Select "Add" in "Select Preset"(listbox), and press "OK".
##  How to Load preset
##    Webdialog::Select Preset_name in "Select Preset"(listbox) and press load_preset button ,then update parameter in dialog.
##    InputBox ::Select Preset_name in "Select Preset"(listbox). and press OK to opdate parameter in dialog.
##  About Make_By_ComponentInstance(listbox)
##    "no" to make furs by mesh.it parts each 800 polgyon.
##    "yes" to make furs by component_instance.it is in one group.component_name is "fur_instance"
##    If ComponentDefinition is exist in model, then component_names are include in listbox.
##    (problem::please don't select component that always face to camera.)
##Rev : 2010-05-07
##  operation go faster works on only sketchup7 upper.
##Rev : 2010-05-08
##  Add "Assign to Material"
##Rev : 2010-05-09   --- v1.2
##  Add  get_furmesh_by_mat( face , mat , ret_furmesh = [] ) for any exporters.
##  webdialog refresh method changed.
##Rev : 2010-05-18   --- v1.3a
##  Add new parameter "direction" and "force"
##  Add menu "imperial" and "metric"
##  Change preset ini format.(not Interchangeable before)
##Rev : 2010-05-19 --- v1.3b
##  Change Component Instance Place method.(ex. Direction change to "0,0,100" instance stand vertical)
##Rev : 2010-05-20 --- v1.3c
##  using "to_l" method.get active model units.but it has accuracy problem.
##  auto select imperial or metric.
##  too small density makes probability.
##Rev : 2010-05-20 --- v1.3d
##  plugin filename keep to "fur_en.rb"
##  ".to_l"method is decimals fixing.so check to value is 0.and calculate by macro.
##  problem about parameter includes blank is fixed.
##  Charset that script using change from "shift-jis" to "UTF-8"(I mistake. this still "shift-jis")
##  Quotation Problem in webdialog is fixed.
##Rev : 2010-05-20 --- v1.3e
##  Change getting delimiter from decimal_separater.(Thanks ThomThom)
##  Menu name keeps "fur_en..." for future.
##Rev : 2010-05-21 --- v1.3f
##  Problem about LengthFormat Architectural ,and LengthPrecision 0.
##  s_to_l defn changes.but it has problem still.
##Rev : 2010-05-21 --- v1.3g
##  vetcor parameter like Direction and force ,split to 3 parametr each other.
##  string to length has problem.Few are fixed.
##  But Units Type "Industrial" is error.Minus value change to "-0".
##Rev : 2010-05-22 --- v1.3h
##  Web dialog become smaller.
##  Defn for any exporter is fixed.
##Rev : 2010-05-23 --- v1.3i
##  Webdialog layout changed.(Thanks Diego.)
##  Local Lang file(fur_lang_**.txt) use to change parameter names.
require 'sketchup.rb'

class FUR_EN
	FUR_DIC_PREFIX = "FUR_DIC2"
	FUR_PRESET_FILE = "fur_param3.ini"
	@delim = "," if @delim == nil
	def get_langconvert
		@langhash = Hash.new
		fur_lang_file = "fur_lang_\*.txt"
		thisdir = File.dirname(File.expand_path(__FILE__))
		langfilelist = []
		Dir::chdir(thisdir)
		path = thisdir + "\/#{fur_lang_file}"
		Dir::glob(path).each{|path|
			lang_file=File.new(path,"r")##read mode
			lang_file.each{|line|
				if line != "" and line["\|"]
					splt = ( line.chomp ).split("\|")
					@langhash[splt[0]] = splt[1] if splt[0] != "" and splt[1] != ""
				end
			}
		}
	end
	def langconv( tstr )
		if @langhash.size > 0
			ret = @langhash[tstr] if @langhash[tstr] != nil
			ret = tstr if ret == ""
		else
			ret = tstr
		end
		return ret
	end
	def get_dialogitems()
		prefix = "%.4g"
		dlg = []
		dlg.push ["#{langconv('Type')}","Arch","Linear|Arch|Leaf|Rectanguler|Box","ftype"]#10
		if @fur_units_metric == true
			dlg.push ["#{langconv('Density')}(Num/m2)","200","","fdensity"]#0
		else
			dlg.push ["#{langconv('Density')}(Num/sq.yd)","170","","fdensity"]#0
		end
		dlg.push ["#{langconv('MaxNumber')}(/Face)","200","","maxnum"]#1
		dlg.push ["#{langconv('Length')}(#{0.to_l})",s_to_l("200mm"),"","flength"]#2
		dlg.push ["#{langconv('RootWidth')}(#{0.to_l})",s_to_l("40mm"),"","frootw"]#3
		dlg.push ["#{langconv('Stiffness')}","8","","fstrong"]#4
		dlg.push ["#{langconv('TopJitter')}(%)","40","","fljitter"]#5
		dlg.push ["#{langconv('WidthJitter')}(%)","25","","fwjitter"]#6
		dlg.push ["#{langconv('StiffnessJitter')}(%)","50","","fsjitter"]#7
		dlg.push ["#{langconv('Divide')}","3","","fdivs"]#8
		dlg.push ["#{langconv('Valid Distance')}(#{0.to_l})",s_to_l("0mm"),"","fvradius"]#9
		#
		dlg.push ["#{langconv('direction')}(X)","#{(0.mm).to_l}","","fdirectionx"]#11
		dlg.push ["#{langconv('direction')}(Y)","#{(0.mm).to_l}","","fdirectiony"]#11
		dlg.push ["#{langconv('direction')}(Z)","#{s_to_l('50mm')}","","fdirectionz"]#11
		dlg.push ["#{langconv('force')}(X)","#{(0.mm).to_l}","","fforcex"]#12
		dlg.push ["#{langconv('force')}(Y)","#{(0.mm).to_l}","","fforcey"]#12
		dlg.push ["#{langconv('force')}(Z)","#{s_to_l('-50mm')}","","fforcez"]#12
		dfnames = []
		dfnames = get_complist
		#defs = Sketchup.active_model.definitions
		#dfnames = []
		#defs.each{|df|
		#	dfnames.push df.name if df.group? == false and df.name != "fur_instance"
		#}
		#alist = "yes|no|fur_instance"
		#alist = alist + "|" + dfnames.join("|") if dfnames.length > 0
	    dlg.push ["#{langconv('Make by Component')}","no",dfnames.join("|"),"instance"]#11
		if @fur_units_metric == true
			dlg.push ["#{langconv('Units')}","metric","metric","funits"]#12
		else
			dlg.push ["#{langconv('Units')}","imperial","imperial","funits"]#12
		end
	    return dlg
	end
	def get_complist
		defs = Sketchup.active_model.definitions
		dfnames = ["yes","no","fur_instance"]
		defs.each{|df|
			dfnames.push df.name if df.group? == false and df.name != "fur_instance"
		}
		return dfnames
	end
	def get_param( ent )
		#model = Sketchup.active_model
		#fdic = model.attribute_dictionary FUR_DIC_PREFIX
		fdic = ent.attribute_dictionary FUR_DIC_PREFIX
		return nil if fdic == nil
		phash = Hash.new
		fdic.each{|key ,val| phash[key] = val }
		prefix = "%.4g"
		phash["funits"] = "metric" if phash["funits"] == ""
		
		#phash['flength'] = "#{s_to_l(phash['flength'])}" if phash['flength'] != ""
		#phash['frootw'] = "#{s_to_l(phash['frootw'])}" if phash['frootw'] != ""
		#phash['fvradius'] = "#{s_to_l(phash['fvradius'])}" if phash['fvradius'] != ""
		#phash['fdirectionx'] = "#{s_to_l(phash['fdirectionx'])}" if phash['fdirectionx'] != ""
		#phash['fdirectiony'] = "#{s_to_l(phash['fdirectiony'])}" if phash['fdirectiony'] != ""
		#phash['fdirectionz'] = "#{s_to_l(phash['fdirectionz'])}" if phash['fdirectionz'] != ""
		#phash['fforcex'] = "#{s_to_l(phash['fforcex'])}" if phash['fforcex'] != ""
		#phash['fforcey'] = "#{s_to_l(phash['fforcey'])}" if phash['fforcey'] != ""
		#phash['fforcez'] = "#{s_to_l(phash['fforcez'])}" if phash['fforcez'] != ""
		phash['flength'] = "#{s_to_l((phash['flength']).to_f.inch)}" if phash['flength'] != ""
		phash['frootw'] = "#{s_to_l((phash['frootw']).to_f.inch)}" if phash['frootw'] != ""
		phash['fvradius'] = "#{s_to_l((phash['fvradius']).to_f.inch)}" if phash['fvradius'] != ""
		phash['fdirectionx'] = "#{s_to_l((phash['fdirectionx']).to_f.inch)}" if phash['fdirectionx'] != ""
		phash['fdirectiony'] = "#{s_to_l((phash['fdirectiony']).to_f.inch)}" if phash['fdirectiony'] != ""
		phash['fdirectionz'] = "#{s_to_l((phash['fdirectionz']).to_f.inch)}" if phash['fdirectionz'] != ""
		phash['fforcex'] = "#{s_to_l((phash['fforcex']).to_f.inch)}" if phash['fforcex'] != ""
		phash['fforcey'] = "#{s_to_l((phash['fforcey']).to_f.inch)}" if phash['fforcey'] != ""
		phash['fforcez'] = "#{s_to_l((phash['fforcez']).to_f.inch)}" if phash['fforcez'] != ""
		
		phash["fdirection"] == "#{phash['fdirectionx']}&&#{phash['fdirectiony']}&&#{phash['fdirectionz']}"
		phash["fforce"] == "#{phash['fforcex']}&&#{phash['fforcey']}&&#{phash['fforcez']}"
		if phash["funits"] == "imperial" and @fur_units_metric == true
				phash['fdensity'] = "#{prefix % ( phash['fdensity'].to_f * 1.19596096 )}" if phash['fdensity'] != ""
				phash["funits"] = "metric"
		elsif phash["funits"] == "metric" and @fur_units_metric == false
				phash['fdensity'] = "#{prefix % ( phash['fdensity'].to_f / 1.19596096 )}" if phash['fdensity'] != ""
				phash["funits"] = "imperial"
		end
		return nil if phash.length <= 0
		return phash
	end
	def put_param( ent ,rhash )
		#model=Sketchup.active_model
		attrdict = ent.attribute_dictionary( FUR_DIC_PREFIX , true )
		rhash.each{|key,val|
			if key.to_s != ""
				if key.to_s == "flength" or key.to_s == "frootw" or key.to_s == "fvradius"
					attrdict[ key ] = s_to_l(val).to_f.to_inch.to_s
				elsif key.to_s == "fforcex" or key.to_s == "fforcey" or key.to_s == "fforcez"
					attrdict[ key ] = s_to_l(val).to_f.to_inch.to_s
				elsif key.to_s == "fdirectionx" or key.to_s == "fdirectiony" or key.to_s == "fdirectionz"
					attrdict[ key ] = s_to_l(val).to_f.to_inch.to_s
				else
					attrdict[ key ] = val
				end
			end
		}
	end

	def del_param_from_scene(  )
		model = Sketchup.active_model
		fdics = model.attribute_dictionaries
		return nil if fdics == nil
		fdics.delete FUR_DIC_PREFIX
	end
	def save_preset_to_ini( rhash , presetname )
		return if rhash == nil
		saveline = presetname.to_s
		rhash.each{|key , val|
				if key.to_s != ""
					if key.to_s == "flength" or key.to_s == "frootw" or key.to_s == "fvradius"
						val2 = s_to_l(val).to_f.to_inch.to_s
					elsif key.to_s == "fforcex" or key.to_s == "fforcey" or key.to_s == "fforcez"
						val2 = s_to_l(val).to_f.to_inch.to_s
					elsif key.to_s == "fdirectionx" or key.to_s == "fdirectiony" or key.to_s == "fdirectionz"
						val2 = s_to_l(val).to_f.to_inch.to_s
					else
						val2 = val
					end
				#val2 = val.gsub(@delim,"&&")
				#val2.gsub!(@decimal_sep,".")
				saveline =  saveline + "&&&#{key}|#{val2}"
				end
		}
		thisdir = File.dirname(File.expand_path(__FILE__))
		path = thisdir + "\/#{FUR_PRESET_FILE}"
		ini_file=File.new(path,"a")##append mode
		ini_file.puts saveline
		ini_file.close
	end
	def load_preset( presetname , defaults ,idns )
		return if presetname == nil or presetname == ""
		params = []
		thisdir = File.dirname(File.expand_path(__FILE__))
		path = thisdir + "\/#{FUR_PRESET_FILE}"
		phash = Hash.new
		if FileTest.exist?(path)
			ini_file=File.new(path,"r")##read mode
			ini_file.each{|line|
				if line != ""
					splt = ( line.chomp ).split("&&&")
					if splt[0] == presetname
						splt.each_with_index{|pr , id|
							#UI.messagebox pr + "," + splt2.join(",")
							if pr["\|"] and id != 0
								splt2 = pr.split(/\|/)
								phash[splt2[0].to_s] = splt2[1].to_s #.gsub(".",@decimal_sep).gsub("&&",@delim)
							end
						}
					end
				end
			}
			ini_file.close
			prefix = "%.4g"
			phash["funits"] = "metric" if phash["funits"] == nil
			if phash["funits"] == "imperial" and @fur_units_metric == true
				phash['fdensity'] = "#{prefix % ( phash['fdensity'].to_f * 1.19596096 )}" if phash['fdensity'] != ""
				phash["funits"] = "metric"
			elsif phash["funits"] == "metric" and @fur_units_metric == false
				phash['fdensity'] = "#{prefix % ( phash['fdensity'].to_f / 1.19596096 )}" if phash['fdensity'] != ""
				phash["funits"] = "imperial"
			end
			phash['flength'] = "#{s_to_l(phash['flength'].to_f.inch)}" if phash['flength'] != ""
			phash['frootw'] = "#{s_to_l(phash['frootw'].to_f.inch)}" if phash['frootw'] != ""
			phash['fvradius'] = "#{s_to_l(phash['fvradius'].to_f.inch)}" if phash['fvradius'] != ""
			phash['fdirectionx'] = "#{s_to_l(phash['fdirectionx'].to_f.inch)}" if phash['fdirectionx'] != ""
			phash['fdirectiony'] = "#{s_to_l(phash['fdirectiony'].to_f.inch)}" if phash['fdirectiony'] != ""
			phash['fdirectionz'] = "#{s_to_l(phash['fdirectionz'].to_f.inch)}" if phash['fdirectionz'] != ""
			phash['fforcex'] = "#{s_to_l(phash['fforcex'].to_f.inch)}" if phash['fforcex'] != ""
			phash['fforcey'] = "#{s_to_l(phash['fforcey'].to_f.inch)}" if phash['fforcey'] != ""
			phash['fforcez'] = "#{s_to_l(phash['fforcez'].to_f.inch)}" if phash['fforcez'] != ""
			phash["fdirection"] == "#{phash['fdirectionx']}&&#{phash['fdirectiony']}&&#{phash['fdirectionz']}"
			phash["fforce"] == "#{phash['fforcex']}&&#{phash['fforcey']}&&#{phash['fforcez']}"

			(0..(idns.size-1)).each{|i|
				if phash[idns[i]] != nil
					params[i] = phash[idns[i]]
				end
			}
			#UI.messagebox phash.keys.join(",") + phash.values.join(",")
			#UI.messagebox params.join(",")
			return nil if params.length <= 0
			return params
		else
			return nil
		end
	end
	def get_presetnames
		presetnames = ""
		thisdir = File.dirname(File.expand_path(__FILE__))
		path = thisdir + "\/#{FUR_PRESET_FILE}"
		if FileTest.exist?(path)
			ini_file=File.new(path,"r")##read mode
			ini_file.each{|line|
				pname = (line.chomp).split("&&&")
				presetnames = presetnames + "|" + pname[0] if pname[0] != ""
			}
			ini_file.close
			return presetnames
		else
			return nil
		end
	end
	def fur_inputbox( fur_unit )
		#@fur_units_metric = fur_unit
		fur_dialog_ini
		dlg = get_dialogitems
	    prompts = []
	    defaults = []
	    lists = []
	    idns = Hash.new
	    ids = Hash.new
	    id = 0
	    dlg.each{|prp,dfl,lst,idn|
			prompts.push prp
			defaults.push dfl
			lists.push lst
			idns[id] = idn
			ids[idn] = id
			id += 1
		}
		params = []
		ohash = get_param( Sketchup.active_model )
		if ohash != nil
			idns.keys.each{|id|
				a = ohash[ idns[id] ]
				if a != nil
					params[id] = a
				end
			}
		end
		defaults1 =	defaults.map{|prp| prp }
		if params.size > 0
			( 0..(params.size-1) ).each{|id|
				defaults1[id] = params[id] if defaults1.length > id
			}
		end

		fdensity = ""
		maxnum = ""
		flength = ""
		frootw = ""
		fdivs = ""
		fstrong = ""

		fj = ""
		fwjitter = ""
		fsjitter = ""
		fdivs = ""
		fvradius = ""
		ftype = ""
		finstance = ""
		funits = ""
		save_preset = ""
		results = []
		reload = ""
		title = "Fur settings."
		title1 = "Fur settings."
		is_df_exist = false
		while( fdensity.to_f == 0 or maxnum.to_f == 0 or s_to_l(flength) == 0 or s_to_l(frootw) == 0 or fdivs.to_f == 0 or fstrong.to_f == 0 or reload == "" or is_df_exist == false)
			prompts2 = prompts.map{|prp| prp }
			prompts2.push "SELECT PRESET(BLANK to Start Fur)"
			defaults2 = defaults1.map{|prp| prp }
			defaults2.push ""
			lists2 = lists.map{|prp| prp }
			presetnames = get_presetnames
			if presetnames != nil
				lists2.push "|default|add|assign_material|get_from_material" + presetnames
			else
				lists2.push "|default|add|assign_material|get_from_material"
			end
			results = UI.inputbox prompts2 , defaults2, lists2, title1
			return if results == false or results == nil
			rhash = Hash.new
			results.each_with_index{|res , i|
				#if idns[i] == "flength" or idns[i] == "frootw" or idns[i] == "fvradius"
				#	rhash[idns[i]] = s_to_l(res).to_inch.to_s
				#elsif idns[i] == "fforcex" or idns[i] == "fforcey" or idns[i] == "fforcez"
				#	rhash[idns[i]] = s_to_l(res).to_inch.to_s
				#elsif idns[i] == "fdirectionz" or idns[i] == "fdirectiony" or idns[i] == "fdirectionz"
				#	rhash[idns[i]] = s_to_l(res).to_inch.to_s
				#else
					rhash[idns[i]] = res
				#end
			}
			
			fdensity = results[ ids["fdensity"] ]
			maxnum = results[ ids["maxnum"] ]
			flength = results[ ids["flength"] ]
			frootw = results[ ids["frootw"] ]
			fstrong = results[ ids["fstrong"] ]
			fj = results[ ids["fljitter"] ]
			fwjitter = results[ ids["fwjitter"] ]
			fsjitter = results[ ids["fsjitter"] ]
			fdivs = results[ ids["fdivs"] ]
			fvradius = results[ ids["fvradius"] ]
			ftype = results[ ids["ftype"] ]
			finstance = results[ ids["instance"] ]
			
			fdirectionx = results[ ids["fdirectionx"] ]
			fdirectiony = results[ ids["fdirectiony"] ]
			fdirectionz = results[ ids["fdirectionz"] ]
			fdirection = "#{fdirectionx}&&#{fdirectiony}&&#{fdirectionz}"
			fforcex = results[ ids["fforcex"] ]
			fforcey = results[ ids["fforcey"] ]
			fforcez = results[ ids["fforcez"] ]
			fforce = "#{fforcex}&&#{fforcey}&&#{fforcez}"

			funits = results[ ids["funits"] ]
			save_preset = results[ results.size - 1 ]
			is_df_exist = false
			if finstance != "yes" and finstance != "no" and finstance != "fur_instance"
				Sketchup.active_model.definitions.each{|df|
					is_df_exist = true if df.name == finstance and df.group? == false
				}
			else
				is_df_exist = true
			end

			if save_preset == ""
				reload = "continue"
			elsif save_preset == "add"
				presetname1 = ""
				pnames = get_presetnames
				pnames = "" if pnames == nil
				pnlist = pnames.split("|")
				while( presetname1 == "" or pnlist.index( presetname1 ) != nil )
					presetname = UI.inputbox ["PRESET_NAME"], [""], "Input preset name"
					break if presetname == false or presetname == nil
					presetname1 = presetname[0]
				end
				if presetname == false or presetname == nil or presetname1 == ""
				else
					save_preset_to_ini rhash , presetname[0]
					#results[13] = ""
					defaults1 = results.map{|prp| prp }
					reload = ""
					title1 = title + "--" + presetname[0]
				end
			elsif save_preset == "default"
				defaults1 = defaults.map{|prp| prp }
				reload = ""
				title1 = title + "--default"
			elsif save_preset == "assign_material"
				defaults1 = results.map{|prp| prp }
				cmat = Sketchup.active_model.materials.current
				put_param cmat , rhash if cmat != nil
				reload = ""
				title1 = title + cmat.name
			elsif save_preset == "get_from_material"
				cmat = Sketchup.active_model.materials.current
				if cmat != nil
					ohash = get_param( cmat )
					if ohash != nil
						idns.keys.each{|id|
							a = ohash[ idns[id] ]
							if a != nil
								params[id] = a
							end
						}
					end
					defaults1 =	defaults.map{|prp| prp }
					if params != nil
						( 0..(params.size-1) ).each{|id|
							defaults1[id] = params[id] if defaults1.length > id
						}
					reload = ""
					title1 = title + cmat.name
					end
				end
			else
				prvalue = load_preset( save_preset , defaults , idns )
				defaults1 = prvalue.map{|prp| prp } if prvalue != nil
				reload = ""
				title1 = title + "--" + save_preset
			end
		end
		put_param Sketchup.active_model , rhash
		#@funits = funits.to_s
		#if @funits == "imperial"
		#	@fdensity = fdensity.to_f * 1.19596096
		#	@flength = flength.to_l.inch
		#	@frootw = frootw.to_l.inch
		#	@fvradius = fvradius.to_l.inch
		#else
			@fdensity = fdensity.to_f
			@flength = s_to_l(flength)
			@frootw = s_to_l(frootw)
			@fvradius = s_to_l(fvradius)
		#end
		@maxnum = maxnum.to_i
		@fj = fj.to_f / 100
		@flj = @fj * @flength.to_f
		@fljitter = Geom::Vector3d.new( @fj * @flength , @fj * @flength , @fj * @flength )
		@fwjitter = fwjitter.to_f * @frootw.to_f / 100
		@fdivs = fdivs.to_i
		@fstrong = fstrong.to_f
		@fsjitter = fsjitter.to_f * @fstrong.to_f / 100
		@finstance = finstance.to_s
		@ftype = ftype.to_s
		@fdirection = Geom::Vector3d.new( s_to_l(fdirectionx) , s_to_l(fdirectiony) , s_to_l(fdirectionz))
		@fforce = Geom::Vector3d.new( s_to_l(fforcex) , s_to_l(fforcey) , s_to_l(fforcez))
		glowup
	end
	def show_webdialog( prompts2 , defaults2 , lists2 , idns , ids, title1 , defaults1 , defaults ,prompts ,lists, title )
		prompts2 = prompts.map{|prp| prp }
		prompts2.push "#{langconv('PRESET?')}"
		defaults2 = defaults1.map{|prp| prp }
		defaults2.push ""
		lists2 = lists.map{|prp| prp }
		presetnames = get_presetnames
		if presetnames != nil
			lists2.push "|default" + presetnames
		else
			lists2.push "|default"
		end

		icount = prompts2.length - 1
		dlg2 = (0..icount).map{|i| [ prompts2[i].to_s , defaults2[i].to_s , lists2[i].to_s , idns[i].to_s ] }
		cr = "\n"
		#shtm = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" >' +cr
	    shtm ='<html><head>'#<meta http-equiv="content-type" content="text/html; charset=UTF-8" />'# lang="en"
	    shtm = shtm + "<script type='text/javascript'>"+ cr
	 	shtm = shtm + "function start_fur(obj) {"+ cr
		shtm = shtm + "  window.location='skp:start_fur';"+ cr
	 	shtm = shtm + "}"+ cr
	 	shtm = shtm + "function save_new_preset(obj) {"+ cr
		shtm = shtm + "  window.location='skp:save_new_preset';"+ cr
	 	shtm = shtm + "}"+ cr
	 	shtm = shtm + "function load_preset(obj) {"+ cr
		shtm = shtm + "  window.location='skp:load_preset';"+ cr
	 	shtm = shtm + "}"+ cr
	 	shtm = shtm + "function assign_to_mat(obj) {"+ cr
		shtm = shtm + "  window.location='skp:assign_to_mat';"+ cr
	 	shtm = shtm + "}"+ cr
	 	shtm = shtm + "function get_from_mat(obj) {"+ cr
		shtm = shtm + "  window.location='skp:get_from_mat';"+ cr
	 	shtm = shtm + "}"+ cr
	 	shtm = shtm + "function update_complist(obj) {"+ cr
		shtm = shtm + "  window.location='skp:update_complist';"+ cr
	 	shtm = shtm + "}"+ cr
		shtm = shtm + "--></script>" + cr
	    shtm = shtm + "<style type='text/css'>" + cr
	    shtm = shtm + "<!--" + cr
	    shtm = shtm + "table.fur{" + cr
	    shtm = shtm + "    width:100%;" + cr
	    shtm = shtm + "    border-top:0px;" + cr
	    shtm = shtm + "    border-left:0px;" + cr
	    shtm = shtm + "    border-collapse:collapse;" + cr
	    shtm = shtm + "    border-spacing:0px;" + cr
	    shtm = shtm + "    background-color:#f6f6f6;" + cr
	    shtm = shtm + "    empty-cells:show;" + cr
	    shtm = shtm + "}" + cr
	    shtm = shtm + ".fur td{" + cr
	    shtm = shtm + "    border-right:1px;" + cr
	    shtm = shtm + "    border-bottom:1px;" + cr
	    shtm = shtm + "    padding:0.2em 0.2em;" + cr
	    shtm = shtm + "    font-size:8pt;" + cr
		shtm = shtm + "    font-family: sans-serif;" + cr
		shtm = shtm + "    text-align: right;" + cr
	    shtm = shtm + "}" + cr
	    shtm = shtm + "-->" + cr
	    shtm = shtm + "</style>" + cr
	    shtm = shtm + "</head><body scroll=no>" + cr
	    shtm = shtm + "<table class='fur'><tbody>" + cr
	    cnt = 0
	    complist = []
	    dlg2.each{|prp,dfl,lst,idn|
	    	if idn == "fdirectionx" or idn == "fforcex"
	    		shtm = shtm + "</tbody></table><hr size='1'><table class='fur' ><tbody>" + cr
	    	end
		    shtm = shtm + "<tr>" +cr
	    	if lst == ""
				shtm = shtm + "<td><p align='right';>#{exchange_quot(prp)} :</p></td><td><input type='text' name='#{idn}' id='#{idn}' value='#{exchange_quot(dfl)}'"
				shtm = shtm + " style='width:75px; height: 20px; font-size: 10px; text-align: left; vertical-align: middle;'></td>"+cr
			else
			    shtm = shtm + "<td><p align='right';>#{exchange_quot(prp)} :</p></td>" + cr
			    shtm = shtm + "<td><select name='#{idn}' id='#{idn}' style='width:75px; height: 20px; font-size: 10px; text-align: left; vertical-align: middle' "
			    shtm = shtm + "onClick='update_complist(this)' " if idn == "instance"
			    shtm = shtm + ">" + cr
				lst.split("|").each{|item|
					if item == dfl
					    shtm = shtm + "<OPTION selected value='#{exchange_quot(item)}'>#{exchange_quot(item)}</OPTION>"+cr
					else
					    shtm = shtm + "<OPTION value='#{exchange_quot(item)}'>#{exchange_quot(item)}</OPTION>"+cr
					end
					if idn == "instance"
						complist.push item if item != ""
					end
				}
			    shtm = shtm + "</select></td>"+cr
			end
	    	shtm = shtm + "</tr>" +cr
	    	if idn == "fforcez"
	    		shtm = shtm + "</tbody></table><hr size='1'><table class='fur' ><tbody>" + cr
	    	end
		}
    	shtm = shtm + "</tbody></table>" + cr
	    shtm = shtm + "<input type='button' name='Load Preset' value='Load Preset' onClick='load_preset(this)' style='font-size:10px; width:90px;'>"+cr
	    shtm = shtm + "<input type='button' name='Save NewPreset' value='Save NewPreset' onClick='save_new_preset(this)' style='font-size:10px; width:90px;'>"+cr
    	shtm = shtm + "<br>" + cr
	    shtm = shtm + "<input type='button' name='Assign to Material' value='Assign to Material' onClick='assign_to_mat(this)' style='font-size:10px; width:90px;'>"+cr
	    shtm = shtm + "<input type='button' name='Get From Material' value='Get From Material' onClick='get_from_mat(this)' style='font-size:10px; width:90px;'>"+cr
    	shtm = shtm + "<br>" + cr
	    shtm = shtm + "<input type='button' name='Make Fur' value='Make Fur' onClick='start_fur(this)' style='font-size:12px; width:190px;'>"+cr
	    shtm = shtm + "</body></html>"

		@wdlg = UI::WebDialog.new( title1, true, "Units Picker", 100, 100, 150, 150, true)
		shtm.gsub!(/\'/,"\"")
		@wdlg.set_html(shtm)

	    @wdlg.add_action_callback("update_complist"){|d,p|
		    dfnames = []
		    addfname = []
		    dfnames = get_complist
		    dfnames.each{|dfname|
		    	if complist.index( dfname ) == nil
		    		addfname.push dfname
					@wdlg.execute_script( "document.getElementById('instance').options[document.getElementById('instance').length] = new Option('#{dfname}','#{dfname}')" )
				end
			}
			addfname.each{|adname| complist.push adname }
	    }
	    @wdlg.add_action_callback("save_new_preset"){|d,p|
			fdensity = @wdlg.get_element_value("fdensity")
			maxnum = @wdlg.get_element_value("maxnum")
			flength = @wdlg.get_element_value("flength")
			frootw = @wdlg.get_element_value("frootw")
			fj = @wdlg.get_element_value("fljitter")
			fwjitter = @wdlg.get_element_value("fwjitter")
			fdivs = @wdlg.get_element_value("fdivs")
			fvradius = @wdlg.get_element_value("fvradius")
			fstrong = @wdlg.get_element_value("fstrong")
			fsjitter = @wdlg.get_element_value("fsjitter")
			ftype = @wdlg.get_element_value("ftype")
			finstance = @wdlg.get_element_value("instance")
			funits = @wdlg.get_element_value("funits")

			fdirectionx = @wdlg.get_element_value("fdirectionx")
			fdirectiony = @wdlg.get_element_value("fdirectiony")
			fdirectionz = @wdlg.get_element_value("fdirectionz")
			fdirection = fdirectionx + "&&" + fdirectiony + "&&" + fdirectionz

			fforcex = @wdlg.get_element_value("fforcex")
			fforcey = @wdlg.get_element_value("fforcey")
			fforcez = @wdlg.get_element_value("fforcez")
			fforce = fforcex + "&&" + fforcey + "&&" + fforcez

			save_preset = @wdlg.get_element_value("save_preset")
			rhash = Hash.new
			results = []
			idns.each{|key,val|
				#if val.to_s == "flength" or val.to_s == "frootw" or val.to_s == "fvradius"
				#	rhash[val.to_s] =  s_to_l( @wdlg.get_element_value("#{val}")).to_inch.to_s
				#elsif val.to_s == "fforcex" or val.to_s == "fforcey" or val.to_s == "fforcez"
				#	rhash[ val.to_s ] = s_to_l( @wdlg.get_element_value("#{val}")).to_inch.to_s
				#elsif val.to_s == "fdirectionz" or val.to_s == "fdirectiony" or val.to_s == "fdirectionz"
				#	rhash[ val.to_s ] = s_to_l( @wdlg.get_element_value("#{val}")).to_inch.to_s
				#else
					rhash[val.to_s] =  @wdlg.get_element_value("#{val}")
				#end
			}
			#results = [fdensity,maxnum ,flength,frootw,fstrong,fj,fwjitter,fsjitter,fdivs,fvradius,ftype,finstance,funits,save_preset]
			idns.keys.each{|id|
				a = rhash[ idns[id] ]
				if a != nil
					results[id] = a
				end
			}
			if  fdensity.to_f == 0 or maxnum.to_f == 0 or s_to_l(flength) == 0 or s_to_l(frootw) == 0 or fdivs.to_f == 0 or fstrong.to_f == 0
			else
				presetname1 = ""
				pnames = get_presetnames
				pnames = "" if pnames == nil
				pnlist = pnames.split("|")
				while( presetname1 == "" or pnlist.index( presetname1 ) != nil )
					presetname = UI.inputbox ["PRESET_NAME"], [""], "Input preset name"
					break if presetname == false or presetname == nil
					presetname1 = presetname[0]
				end
				if presetname == false or presetname == nil or presetname1 == ""
				else
					save_preset_to_ini rhash , presetname1
					#results[13] = ""
					defaults1 = results.map{|prp| prp }
					reload = ""
					title1 = title + "--" + presetname1
					@wdlg.execute_script( "document.getElementById('save_preset').options[document.getElementById('save_preset').length] = new Option('#{presetname1}','#{presetname1}')" )
					#@wdlg.close
					#show_webdialog prompts2 , defaults1 , lists2 , idns, title1 , defaults1 , defaults ,prompts ,lists, title 
				end
			end
		}
	    @wdlg.add_action_callback("load_preset"){|d,p|
			save_preset = @wdlg.get_element_value("save_preset")
			if save_preset == "default"
				defaults1 = defaults.map{|prp| prp }
				reload = ""
				title1 = title + "--default"
				defaults1.each_with_index{|prp,id|
					@wdlg.execute_script( "document.getElementById('#{idns[id]}').value = '#{exchange_quot2( prp )}'" )
				}
				@wdlg.execute_script( "document.title = '#{title1}'" )
				#@wdlg.close
				#show_webdialog prompts2 , defaults1 , lists2 , idns, title1 , defaults1 , defaults ,prompts ,lists, title 
			elsif save_preset != ""
				prvalue = load_preset( save_preset , defaults , idns)
				defaults1 = prvalue.map{|prp| prp } if prvalue != nil
				reload = ""
				title1 = title + "--" + save_preset
				defaults1.each_with_index{|prp,id|
					@wdlg.execute_script( "document.getElementById('#{idns[id]}').value = '#{exchange_quot2( prp )}'" )
				}
				@wdlg.execute_script( "document.title = '#{title1}'" )
				#@wdlg.close
				#show_webdialog prompts2 , defaults1 , lists2 , idns, title1 , defaults1 , defaults ,prompts ,lists, title 
			end
		}
	    @wdlg.add_action_callback("get_from_mat"){|d,p|
			cmat = Sketchup.active_model.materials.current
			if cmat != nil
				ohash = get_param( cmat )
				if ohash != nil
					params = []
					idns.keys.each{|id|
						a = ohash[ idns[id] ]
						if a != nil
							params[id] = a
						end
					}
					if params != nil
						defaults1 =	defaults.map{|prp| prp }
						( 0..(params.size-1) ).each{|id|
							defaults1[id] = params[id] if defaults1.length > id
						}
						defaults1.each_with_index{|prp,id|
							@wdlg.execute_script( "document.getElementById('#{idns[id]}').value = '#{exchange_quot2(prp)}'" )
						}
						#wdlg.close
						#show_webdialog prompts2 , defaults1 , lists2 , idns, title1 , defaults1 , defaults ,prompts ,lists, title
					end
				end
			end
		}
	    @wdlg.add_action_callback("assign_to_mat"){|d,p|
			#fdensity = @wdlg.get_element_value("fdensity")
			#maxnum = @wdlg.get_element_value("maxnum")
			#flength = @wdlg.get_element_value("flength")
			#frootw = @wdlg.get_element_value("frootw")
			#fj = @wdlg.get_element_value("fljitter")
			#fwjitter = @wdlg.get_element_value("fwjitter")
			#fdivs = @wdlg.get_element_value("fdivs")
			#fvradius = @wdlg.get_element_value("fvradius")
			#fstrong = @wdlg.get_element_value("fstrong")
			#fsjitter = @wdlg.get_element_value("fsjitter")
			#ftype = @wdlg.get_element_value("ftype")
			#finstance = @wdlg.get_element_value("instance")
			#funits = @wdlg.get_element_value("funits")
			#save_preset = @wdlg.get_element_value("save_preset")
			rhash = Hash.new
			idns.each{|key,val|
				#if val.to_s == "flength" or val.to_s == "frootw" or val.to_s == "fvradius"
				#	rhash[val.to_s] =  s_to_l( @wdlg.get_element_value("#{val}")).to_inch.to_s
				#elsif val.to_s == "fforcex" or val.to_s == "fforcey" or val.to_s == "fforcez"
				#	rhash[ val.to_s ] = s_to_l( @wdlg.get_element_value("#{val}")).to_inch.to_s
				#elsif val.to_s == "fdirectionz" or val.to_s == "fdirectiony" or val.to_s == "fdirectionz"
				#	rhash[ val.to_s ] = s_to_l( @wdlg.get_element_value("#{val}")).to_inch.to_s
				#else
					rhash[val.to_s] =  @wdlg.get_element_value("#{val}")
				#end
			}

			#idns.each{|key,val| rhash[val.to_s] =  @wdlg.get_element_value("#{val}") }
			#results = [fdensity,maxnum ,flength,frootw,fstrong,fj,fwjitter,fsjitter,fdivs,fvradius,ftype,finstance,funits,save_preset]
			cmat = Sketchup.active_model.materials.current
			put_param cmat , rhash if cmat != nil
		}
	    @wdlg.add_action_callback("start_fur"){|d,p|
			rhash = Hash.new
			idns.each{|key,val|
				#if val.to_s == "flength" or val.to_s == "frootw" or val.to_s == "fvradius"
				#	rhash[val.to_s] =  s_to_l( @wdlg.get_element_value("#{val}")).to_inch.to_s
				#elsif val.to_s == "fforcex" or val.to_s == "fforcey" or val.to_s == "fforcez"
				#	rhash[ val.to_s ] = s_to_l( @wdlg.get_element_value("#{val}")).to_inch.to_s
				#elsif val.to_s == "fdirectionz" or val.to_s == "fdirectiony" or val.to_s == "fdirectionz"
				#	rhash[ val.to_s ] = s_to_l( @wdlg.get_element_value("#{val}")).to_inch.to_s
				#else
					rhash[val.to_s] =  @wdlg.get_element_value("#{val}")
				#end
			}
			#idns.each{|key,val| rhash[val.to_s] =  @wdlg.get_element_value("#{val}") }

			fdensity = @wdlg.get_element_value("fdensity")
			maxnum = @wdlg.get_element_value("maxnum")
			flength = @wdlg.get_element_value("flength")
			frootw = @wdlg.get_element_value("frootw")
			fj = @wdlg.get_element_value("fljitter")
			fwjitter = @wdlg.get_element_value("fwjitter")
			fdivs = @wdlg.get_element_value("fdivs")
			fvradius = @wdlg.get_element_value("fvradius")
			fstrong = @wdlg.get_element_value("fstrong")
			fsjitter = @wdlg.get_element_value("fsjitter")
			ftype = @wdlg.get_element_value("ftype")
			finstance = @wdlg.get_element_value("instance")
			funits = @wdlg.get_element_value("funits")
			fdirectionx = @wdlg.get_element_value("fdirectionx")
			fdirectiony = @wdlg.get_element_value("fdirectiony")
			fdirectionz = @wdlg.get_element_value("fdirectionz")
			fdirection = fdirectionx + "&&" + fdirectiony + "&&" + fdirectionz

			fforcex = @wdlg.get_element_value("fforcex")
			fforcey = @wdlg.get_element_value("fforcey")
			fforcez = @wdlg.get_element_value("fforcez")
			fforce = fforcex + "&&" + fforcey + "&&" + fforcez
			save_preset = @wdlg.get_element_value("save_preset")

			#results = [fdensity,maxnum ,flength,frootw,fstrong,fj,fwjitter,fsjitter,fdivs,fvradius,ftype,finstance,funits,save_preset]
			is_df_exist = false
			if finstance != "yes" and finstance != "no" and finstance != "fur_instance"
				Sketchup.active_model.definitions.each{|df|
					is_df_exist = true if df.name == finstance and df.group? == false
				}
			else
				is_df_exist = true
			end
			if  fdensity.to_f == 0 or maxnum.to_f == 0 or s_to_l(flength) == 0 or s_to_l(frootw) == 0 or fdivs.to_f == 0 or fstrong.to_f == 0 or is_df_exist == false
				#nothing execute
			else #if save_preset == ""
				#@funits = funits.to_s
				#if @funits == "imperial"
				#	@fdensity = fdensity.to_f * 1.19596096
				#	@flength = flength.to_l.inch
				#	@frootw = frootw.to_l.inch
				#	@fvradius = fvradius.to_l.inch
				#else
				@fdensity = fdensity.to_f
				@flength = s_to_l(flength)
				@frootw = s_to_l(frootw)
				@fvradius = s_to_l(fvradius)
				#end
				@maxnum = maxnum.to_i
				@fj = fj.to_f / 100
				@flj = @fj * @flength.to_f
				@fljitter = Geom::Vector3d.new( @fj * @flength , @fj * @flength , @fj * @flength )
				@fwjitter = fwjitter.to_f * @frootw.to_f / 100
				@fdivs = fdivs.to_i
				@fstrong = fstrong.to_f
				@fsjitter = fsjitter.to_f * @fstrong.to_f / 100
				@finstance = finstance.to_s
				@ftype = ftype.to_s
				@fdirection = Geom::Vector3d.new( s_to_l(fdirectionx) , s_to_l(fdirectiony) , s_to_l(fdirectionz))
				@fforce = Geom::Vector3d.new( s_to_l(fforcex) , s_to_l(fforcey) , s_to_l(fforcez))
				#@fdirection = s_to_vec( fdirection )
				#@fforce = s_to_vec( fforce )
				put_param Sketchup.active_model ,rhash
				glowup
			end
  	    }
		@dlg_possize = [250,620,200,200]
		@wdlg.show
		@wdlg.set_size 226,640
		@wdlg.set_position 200,200
	end
	
	def exchange_quot( tstr )
		tstr1 = ""
		tstr1 = tstr.gsub("\'",'&#39;')#'
		tstr1.gsub!("\"","\&quot;")#"
		#UI.messagebox tstr1
		return tstr1
	end
	def exchange_quot2( tstr )
		tstr1 = ""
		tstr1 = tstr.to_s.gsub("\'","\\\'")#'
		tstr1.gsub!("\"","\\\"")#"
		#UI.messagebox tstr1
		return tstr1
	end

	def fur_dialog_ini
    
		#units = Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]
		#@fur_units_metric = (units >= 2) # true if units are 2 or greater
		#@decimal_sep = 1.2.to_l.to_s.match(/\d(\D)\d/)[1]
		#@delim = (@decimal_sep == ',') ? ";" : ","
		
		#unitoptions = Hash.new
		#Sketchup.active_model.options["UnitsOptions"].each{|key ,val| unitoptions[key] = val }
		#Sketchup.active_model.options["UnitsOptions"]["LengthFormat"] = 0 if unitoptions["LengthFormat"] != 0
		#Sketchup.active_model.options["UnitsOptions"]["LengthPrecision"] = 1 if unitoptions["LengthPrecision"] == 0
		@fur_units_metric = false
		lunit = Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]
		@fur_units_metric = true if lunit >= 2
		get_langconvert
		#lprec = Sketchup.active_model.options["UnitsOptions"]["LengthPrecision"]
		#@decimal_sep = 1.2.to_l.to_s.match(/\d(\D)\d/)[1]
		#@delim = ","
		#@delim = ";" if @decimal_sep == ','
		#unitoptions.each{|key ,val| Sketchup.active_model.options["UnitsOptions"][key] = val }

		##@fur_units_metric = true if ( 0.to_l.to_s )["m"]
		##0= inch ,1 = feet ,2 = mm , 3= cm ,4 = m
		##@delim = ";" if Sketchup.get_locale.upcase == "FR"
	end
	
	def fur_webdialog( fur_unit )
		#@fur_units_metric = fur_unit
		fur_dialog_ini
	    lang = Sketchup.get_locale.upcase
		dlg = get_dialogitems
	    prompts = []
	    defaults = []
	    lists = []
	    idns = Hash.new
	    ids = Hash.new
	    id = 0
	    dlg.each{|prp,dfl,lst,idn|
			prompts.push prp
			defaults.push dfl
			lists.push lst
			idns[id] = idn
			ids[idn] = id
			id += 1
		}
		idns[dlg.length] = "save_preset"
		params = []
		ohash = get_param( Sketchup.active_model )
		if ohash != nil
			idns.keys.each{|id|
				a = ohash[ idns[id] ]
				if a != nil
					params[id] = a
				end
			}
		end
		defaults1 =	defaults.map{|prp| prp }
		
		if params.size > 0
			( 0..(params.size-1) ).each{|id|
				defaults1[id] = params[id] if defaults1.length > id
			}
		end

		fdensity = ""
		maxnum = ""
		flength = ""
		frootw = ""
		fdivs = ""
		fstrong = ""
		fj = ""
		fwjitter = ""
		fsjitter = ""
		fdivs = ""
		fvradius = ""
		ftype = ""
		finstance = ""
		funits = ""
		save_preset = ""
		#results = []
		reload = ""
		title = "Fur settings."
		title1 = "Fur settings."
		
		prompts2 = prompts.map{|prp| prp }
		defaults2 = defaults1.map{|prp| prp }
		lists2 = lists.map{|prp| prp }

		show_webdialog prompts2 , defaults2 , lists2 , idns , ids, title1 , defaults1 , defaults ,prompts ,lists, title

	end
	##Rev 2010-05-09 add for exporter.
	def get_furmesh_by_mat( face , mat , ret_furmesh = [] )
		#ret_furmesh = [ polygonmesh , uv ]
		if face.is_a?(Sketchup::Face)
		else
			return nil
		end
		if mat != nil
			#fdic = mat.attribute_dictionary FUR_DIC_PREFIX
			fdic = get_param( mat )
			return nil if fdic == nil
			a = fdic[ "fdensity" ]
			@finstance = fdic[ "instance" ].to_s
			return nil if @finstance != "yes" and @finstance != "no" and @finstance != "fur_instance"
			@funits = fdic[ "funits" ].to_s
			@camera = Sketchup.active_model.active_view.camera
			#if @funits == "imperial"
			#	@fdensity = fdic[ "fdensity" ].to_f * 1.19596096
			#	@flength = fdic[ "flength" ].to_l.inch
			#	@frootw = fdic[ "frootw" ].to_l.inch
			#	@fvradius = fdic[ "fvradius" ].to_l.inch
			#else
			@fdensity = fdic[ "fdensity" ].to_f
			@flength = s_to_l(fdic[ "flength" ])
			@frootw = s_to_l(fdic[ "frootw" ])
			@fvradius = s_to_l(fdic[ "fvradius" ])
			#end
			@maxnum = fdic[ "maxnum" ].to_i
			@fforce = Geom::Vector3d.new( 0.0 , 0.0 , 0.05 )
			@fdirection = Geom::Vector3d.new( 0.0 , 0.0 , 0.05 )
			@ftype = fdic[ "ftype" ].to_s

			@fj = fdic[ "fljitter" ].to_f / 100
			@flj = @fj.to_f / 100  * @flength.to_f
			@fljitter = Geom::Vector3d.new( @fj * @flength , @fj * @flength , @fj * @flength )
			@fwjitter = fdic[ "fwjitter"].to_f * @frootw.to_f / 100

			@fstrong = fdic[ "fstrong" ].to_f
			@fsjitter = fdic[ "fsjitter" ].to_f * @fstrong.to_f / 100
			@fdivs = fdic[ "fdivs"].to_i
			@fdivs = @fdivs + 1 if @fvradius != 0

			fdirectionx = s_to_l(fdic['fdirectionx']) if fdic['fdirectionx'] != ""
			fdirectiony = s_to_l(fdic['fdirectiony']) if fdic['fdirectiony'] != ""
			fdirectionz = s_to_l(fdic['fdirectionz']) if fdic['fdirectionz'] != ""
			fforcex = s_to_l(fdic['fforcex']) if fdic['fforcex'] != ""
			fforcey = s_to_l(fdic['fforcey']) if fdic['fforcey'] != ""
			fforcez = s_to_l(fdic['fforcez']) if fdic['fforcez'] != ""
			@fdirection = Geom::Vector3d.new( fdirectionx , fdirectiony , fdirectionz)
			@fforce = Geom::Vector3d.new( fforcex , fforcey , fforcez)
		else
			return nil
		end
		mesh = face.mesh(5)
		nvec = face.normal
		pmesh = Geom::PolygonMesh.new
		#pmeshes = []
		ocnt = 0
		if mesh != nil
			mesh.polygons.each{|poly|
				pt1 = mesh.point_at poly[0]
				pt2 = mesh.point_at poly[1]
				pt3 = mesh.point_at poly[2]
				uv1 = mesh.uv_at( poly[0] ,1 )
				uv2 = mesh.uv_at( poly[1] ,1 )
				uv3 = mesh.uv_at( poly[2] ,1 )
				nor1 = mesh.normal_at poly[0]
				nor2 = mesh.normal_at poly[1]
				nor3 = mesh.normal_at poly[2]
				len12 = pt1.distance pt2
				len13 = pt1.distance pt3
				vec12 = pt1.vector_to pt2
				vec13 = pt1.vector_to pt3
				ang23 = vec12.angle_between vec13
				area123 = len12.to_m * len13.to_m * Math.sin( ang23 ) * 0.5
				cnt = area123.to_f * @fdensity.to_f
				if cnt.to_f < 1.to_f
					if cnt.to_f > rand.to_f
						cnt = 1
					else
						cnt = 0
					end
				end
				cnt = cnt.to_i
				cnt = @maxnum if cnt > @maxnum
				(1..cnt).each{|i|
					pmesh = Geom::PolygonMesh.new
					ra = rand
					rb = 1.to_f - Math.sqrt( rand )
					pt4 = Geom::Point3d.new
					pt4 = point_add( vector_scale( pt2 , ra.to_f ) , vector_scale( pt3 ,( 1.to_f - ra.to_f ) ) )
					pt5 = Geom::Point3d.new
					pt5 = point_add( vector_scale( pt1 , rb.to_f ) , vector_scale( pt4 ,( 1.to_f - rb.to_f ) ) )
					uv4 = Geom::Point3d.new
					uv4.x = uv2.x * ra + uv3.x * (1-ra)
					uv4.y = uv2.y * ra + uv3.y * (1-ra)
					uv5 = Geom::Point3d.new
					uv5.x = uv1.x * rb + uv4.x * (1-rb)
					uv5.y = uv1.y * rb + uv4.y * (1-rb)
					nor4 = Geom::Point3d.new
					nor4 = point_add( vector_scale( nor2 , ra.to_f ) , vector_scale( nor3 ,( 1.to_f - ra.to_f ) ) )
					nor5 = Geom::Point3d.new
					nor5 = point_add( vector_scale( nor1 , rb.to_f ) , vector_scale( nor4 ,( 1.to_f - rb.to_f ) ) )
					divs = @fdivs
				#if @finstance == "no"
					if @fvradius == 0
						make_fur pmesh , pt5 , uv5, nor5 , mat , pt1 ,divs
					else
						cv1 = @camera.eye.vector_to @camera.target
						cv2 = @camera.eye.vector_to pt5
						if cv2.angle_between( cv1 ).to_f <= @camera.fov.degrees.to_f
							pdist = @fvradius.to_f - pt5.distance( @camera.eye )
							pdist = 0 if pdist < 0
							divs = ( @fdivs * Math.sqrt( pdist / @fvradius ) ) .to_i
							make_fur( pmesh , pt5 , uv5, nor5 , mat , pt1 ,divs ) if divs != 0
						end
					end
					if pmesh.count_polygons > 0
						ret_furmesh.push [ pmesh , uv5 ]
						ocnt += pmesh.count_polygons
						Sketchup.set_status_text "Calc #{ocnt} Polygons"
					end
				#end
				}##density loop end
			}##polygons.each
		end##if mesh?
		#ret_furmesh = pmeshes.map{|pm,uv| [ pm , uv ] }
		return true
	end

	def glowup
		model = Sketchup.active_model
		ss = model.selection
		ents = model.entities
		if ss.empty? 
		  UI.messagebox("No selection.")
		  return nil
		end

		return if ss.find{|selface| selface.kind_of? Sketchup::Face } == nil
		starttime = Time.now.to_f

		#@fforce = Geom::Vector3d.new( (0.0).m , (0.001).m , (-0.05).m )
		#@fdirection = Geom::Vector3d.new( (0.0).m , (0.0).m , @flength.to_f / 20 )
		@camera = Sketchup.active_model.active_view.camera
		@fdivs = @fdivs + 1 if @fvradius != 0
		cnt = 0
		
		sfaces = ss.find_all{|selface| selface.is_a?(Sketchup::Face) }
		spgs = sfaces.map{|pg| [pg.mesh(5) , pg.material , pg.normal] }
		ocnt = 0
		pmesh = Geom::PolygonMesh.new
		pmeshes = []
		pcmax = 600
		pcnext = pcmax
		pmat = Sketchup.active_model.materials.current

		fur_inss_list = []
		fur_inss = []
		fur_def = Sketchup.active_model.definitions[ "fur_instance" ]
		if @finstance == "yes" or ( fur_def == nil and @finstance == "fur_instance" )
			fur_def = model.definitions.add( model.definitions.unique_name("fur_instance") )
			make_fur( pmesh , pointXYZ( 0,0,0 ) , pointXYZ( 0,0,0 ) , pointXYZ( 0,0,1 )  , nil , pointXYZ( 1,0,0 ) , @fdivs ,true )
			if @ftype == "Box"
				fur_def.entities.fill_from_mesh( pmesh , false ,0 )
			else
				fur_def.entities.fill_from_mesh( pmesh , false ,12 )
			end
			fur_def.insertion_point = pointXYZ( 0,0,0 )
			fi_pcount = pmesh.count_polygons.to_i + 1.to_i
		elsif @finstance != "no"
			fur_def = Sketchup.active_model.definitions[ @finstance ]
			@finstance = "no" if fur_def == nil
			fi_pcount = 1
		end
		pmesh = Geom::PolygonMesh.new
		spgs.each{|mesh ,mat, nvec|
			if mesh != nil
				mesh.polygons.each{|poly|
					pt1 = mesh.point_at poly[0]
					pt2 = mesh.point_at poly[1]
					pt3 = mesh.point_at poly[2]
					uv1 = mesh.uv_at( poly[0] ,1 )
					uv2 = mesh.uv_at( poly[1] ,1 )
					uv3 = mesh.uv_at( poly[2] ,1 )
					nor1 = mesh.normal_at poly[0]
					nor2 = mesh.normal_at poly[1]
					nor3 = mesh.normal_at poly[2]
					len12 = pt1.distance pt2
					len13 = pt1.distance pt3
					vec12 = pt1.vector_to pt2
					vec13 = pt1.vector_to pt3
					ang23 = vec12.angle_between vec13
					area123 = len12.to_m * len13.to_m * Math.sin( ang23 ) * 0.5
					cnt = area123.to_f * @fdensity.to_f
					if cnt.to_f < 1.to_f
						if cnt.to_f > rand.to_f
							cnt = 1
						else
							cnt = 0
						end
					end
					cnt = cnt.to_i
					cnt = @maxnum if cnt > @maxnum
					(1..cnt).each{|i|
						ra = rand
						rb = 1.to_f - Math.sqrt( rand )
						pt4 = Geom::Point3d.new
						pt4 = point_add( vector_scale( pt2 , ra.to_f ) , vector_scale( pt3 ,( 1.to_f - ra.to_f ) ) )
						pt5 = Geom::Point3d.new
						pt5 = point_add( vector_scale( pt1 , rb.to_f ) , vector_scale( pt4 ,( 1.to_f - rb.to_f ) ) )
						uv4 = Geom::Point3d.new
						uv4.x = uv2.x * ra + uv3.x * (1-ra)
						uv4.y = uv2.y * ra + uv3.y * (1-ra)
						uv5 = Geom::Point3d.new
						uv5.x = uv1.x * rb + uv4.x * (1-rb)
						uv5.y = uv1.y * rb + uv4.y * (1-rb)
						nor4 = Geom::Point3d.new
						nor4 = point_add( vector_scale( nor2 , ra.to_f ) , vector_scale( nor3 ,( 1.to_f - ra.to_f ) ) )
						nor5 = Geom::Point3d.new
						nor5 = point_add( vector_scale( nor1 , rb.to_f ) , vector_scale( nor4 ,( 1.to_f - rb.to_f ) ) )
						divs = @fdivs
						if @finstance != "no"
							fur_inss.push [ pt5 , nor5 , mat ]
							ocnt += fi_pcount
							pmat = mat
							if ( ocnt ) >= pcnext
								ocnt += fi_pcount
								fur_inss_list.push fur_inss
								fur_inss = []
								while pcnext < ( ocnt + pcmax / 2 )
									pcnext += pcmax
								end
								Sketchup.set_status_text "Calc #{ocnt} Polygons"
							end
						else
							if @fvradius == 0
								make_fur pmesh , pt5 , uv5, nor5 , mat , pt1 ,divs
							else
								cv1 = @camera.eye.vector_to @camera.target
								cv2 = @camera.eye.vector_to pt5
								if cv2.angle_between( cv1 ).to_f <= @camera.fov.degrees.to_f
									pdist = @fvradius.to_f - pt5.distance( @camera.eye )
									pdist = 0 if pdist < 0
									divs = ( @fdivs * Math.sqrt( pdist / @fvradius ) ) .to_i
									make_fur( pmesh , pt5 , uv5, nor5 , mat , pt1 ,divs ) if divs != 0
								end
							end
							pmat = mat
							if ( ocnt + pmesh.count_polygons ) >= pcnext
								ocnt += pmesh.count_polygons
								pmeshes.push [ pmesh , mat ]
								pmesh = Geom::PolygonMesh.new
								while pcnext < ( ocnt + pcmax / 2 )
									pcnext += pcmax
								end
								Sketchup.set_status_text "Calc #{ocnt} Polygons"
							end
						end

					}##density loop end

				}##polygons.each
			end##if mesh?
		}
		if Sketchup.version.to_f >= 7
			model.start_operation "fur glow" ,true
		else
			model.start_operation "fur glow"
		end
		oocnt = 0
		fgp = model.active_entities.add_group
		fgents = fgp.entities
		if @finstance != "no"
			if fur_inss.size > 0
				ocnt += fi_pcount
				fur_inss_list.push fur_inss
				Sketchup.set_status_text "Calc #{ocnt} Polygons"
			end

			fur_inss_list.each{|fur_inss|
				fur_inss.each{|pt5 , npt5 , mat|
					nor5 = pointXYZ( 0,0,0 ).vector_to( npt5 )
					nor5.length = @flength.to_f
					nor6 = vector_add( nor5 , vector_scale( @fdirection , 0.5 ) )
					#nor6.length = nor5.length
					flv = vectorXYZ( @fljitter.x * ( 0.5 -rand ),@fljitter.y * ( 0.5 -rand ),@fljitter.z * ( 0.5 -rand ) )
					nor7 = vector_add( nor6 , flv )
					nor7.length = nor5.length
					nor6.length = nor5.length
					if @fdirection.length == 0
						scale_deg = 180.degrees
					else
						scale_deg = ( 90.degrees - nor5.angle_between(nor6) ).abs
						#scale_deg = @fljitter.length.to_f / @fdirection.length.to_f
					end
					scale_deg = 180.degrees if scale_deg > 180.degrees
					scale_deg = 180.degrees if scale_deg < 0
					ra = ( ( 1.0 - rand * 2.0 ) * scale_deg )
					tr = Geom::Transformation.rotation( pointXYZ( 0,0,0 ), vectorXYZ( 0,0,1 ) , ra )
					#nor5 = vector_add( pointXYZ( 0,0,0 ).vector_to( npt5 ) , @fdirection )
					if nor7.samedirection?( vectorXYZ( 0,0,1 ) )
					elsif nor7.samedirection?( vectorXYZ( 0,0,-1 ) )
						tr = Geom::Transformation.rotation( pointXYZ( 0,0,0 ), vectorXYZ( 1,0,0 ) , 180.degrees ) * tr
					else
						zax = nor7
						yax = nor7.cross( vectorXYZ( 0,0,1 ) )
						xax = nor7.cross( yax )
						tr = Geom::Transformation.axes( pointXYZ( 0,0,0 ), xax, yax, zax ) * tr
					end
					ts = Geom::Transformation.scaling( 1 - @fj * ( 1.to_f - rand * 2.to_f ) )
					tr = ts * tr
					tr = Geom::Transformation.translation( pointXYZ( 0,0,0 ).vector_to( pt5 ) ) * tr
					fins = fgents.add_instance fur_def, tr
					fins.material = mat if mat != nil
					Sketchup.set_status_text "Making #{oocnt} polygons / #{ocnt}"
					oocnt += fi_pcount
				}
			}
		else
			if pmesh.count_polygons > 0
				ocnt += pmesh.count_polygons
				pmeshes.push [ pmesh , pmat ]
				Sketchup.set_status_text "Calc #{ocnt} Polygons"
			end
			pmeshes.each{|pmesh , mat|
				if pmesh != nil
					tgp = fgents.add_group
					tgents = tgp.entities
					if @ftype == "Box"
						tgents.fill_from_mesh( pmesh , false ,0 )
					else
						tgents.fill_from_mesh( pmesh , false ,12 )
					end
					tgp.material = mat
					oocnt += pmesh.count_polygons
					Sketchup.set_status_text "Making #{oocnt} polygons / #{ocnt}"
				end
			}
		end

		model.commit_operation
		wastetime = Time.now.to_f - starttime
		Sketchup.set_status_text "waste time is #{wastetime} sec"
	end##def

	def make_fur( pmesh , pt5 , uv5 , nor5 , mat ,pt1 ,divs , inss = false )
		vec_l = Geom::Vector3d.new( nor5.x , nor5.y , nor5.z )
		vec_l.length = @flength.to_f
		if inss == true
			vjitter = Geom::Vector3d.new( @fljitter.x.to_f * ( 3.0 ** 0.5 ) / 2 , 0 , 0 )
			vec_l = vector_add( vec_l , vjitter )
			fdir = vector_scale( @fdirection , @flength.to_f )
		else
			vjitter = Geom::Vector3d.new( @fljitter.x.to_f - @fljitter.x.to_f * rand * 2, @fljitter.y.to_f - @fljitter.y.to_f * rand * 2 , @fljitter.z.to_f - @fljitter.z.to_f * rand * 2 )
			vec_l = vector_add( vec_l , vjitter )
			fdir = vector_scale( @fdirection , @flength.to_f )
			vec_l = vector_add( vec_l , @fdirection )
		end
		vec_l.length = @flength.to_f
		##chk_per = false
		w = (( @frootw.to_f + rand * @fwjitter.to_f ) / 2.to_f ).to_f
		if @fforce.length == 0
			vec_w = pt5.vector_to pt1
			vec_w.length = w
			t = Geom::Transformation.rotation pt5, vec_l, rand * 360.degrees
			vec_w.transform! t
		elsif @fforce.samedirection?( vec_l ) or @fforce.samedirection?( vec_l.reverse )
			vec_w = pt5.vector_to pt1
			vec_w.length = w
			t = Geom::Transformation.rotation pt5, vec_l, rand * 360.degrees
			vec_w.transform! t
		else
			vec_w = vec_l.cross @fforce
			vec_w.length = w
		end
		##pmesh = Geom::PolygonMesh.new
		dvec_l = vector_scale( vec_l ,  ( 1.to_f / divs.to_f ) )
		fstr = @fstrong.to_f + ( 2.to_f * rand - 1.to_f ) * @fsjitter.to_f
		if fstr > 0
			force = vector_scale( @fforce , 1.to_f / fstr.to_f )
		else
			force = vector_scale( @fforce , 1 )
		end
		dforce = vector_scale( force , ( vec_l.length.to_f / divs.to_f ) )
		dvec_l2 = vector_add( dvec_l , dforce )
		dvec_l2.length = dvec_l.length
		pvts0 = Geom::Point3d.new
		pvts1 = Geom::Point3d.new
		pvts2 = Geom::Point3d.new
		pvts3 = Geom::Point3d.new
		dw = Geom::Vector3d.new
		if @ftype == "Box"
			vts = []
			vts2 = []
			vec_d = vec_l.cross vec_w
			vec_d.length = vec_w.length
			vts[0] = point_add( pt5 , vec_w )
			vts[1] = point_add( pt5 , vec_d )
			vts[2] = point_add( pt5 , vec_w.reverse )
			vts[3] = point_add( pt5 , vec_d.reverse )
			pmesh.add_polygon vts
			vts[4] = vts[0]
			(0..3).each{|div|
				vts2[0] = vts[ div ]
				vts2[1] = vts[ div + 1]
				vts2[2] = point_add( vts[ div + 1 ] , vec_l )
				vts2[3] = point_add( vts[ div ] , vec_l )
				pmesh.add_polygon vts2
			}
			(0..3).each{|div|
				vts2[div] = point_add(  vts[ div ] , vec_l )
			}
			pmesh.add_polygon vts2
		else
		(1..divs).each{|div|
			vts = []
			if div == 1
				if @ftype == "Arch" #Linear|Arch|Leaf|Rectanguler
					dw = vector_scale( vec_w , Math.sqrt( 1 - div.to_f / divs.to_f ) )
				elsif @ftype == "Leaf"
					fdy = ( 1.to_f - ( div.to_f + 1.to_f ) / divs.to_f * 2.to_f ).abs ** 0.5
					dw = vector_scale( vec_w , Math.sqrt( fdy ) )
				elsif @ftype == "Rectanguler"
					dw = vec_w
				else
					dw = vector_scale( vec_w , ( 1.to_f - div.to_f / divs.to_f ) )
				end

				if @ftype == "Leaf"
					pvts0 = pt5
					pvts3 = point_add( pt5 , dvec_l2 )
					vts[0] = pvts0
					vts[1] = point_add( pvts3 , dw.reverse )
					vts[2] = point_add( pvts3 , dw )
					pvts1 =  point_add( pvts3 , dw )
					pvts2 = point_add( pvts3 , dw.reverse )
					pvts0 = pvts3
					dvec_l2 = vector_add( dvec_l2 , dforce )
					dvec_l2.length = dvec_l.length
					pvts3 = point_add( pvts3 , dvec_l2 )
				else
					pvts0 = pt5
					pvts1 = point_add( pt5 , vec_w )
					pvts2 = point_add( pt5 , vec_w.reverse )
					pvts3 = point_add( pt5 , dvec_l2 )
					vts[0] = pvts1
					vts[1] = pvts2
					vts[2] = point_add( pvts3 , dw.reverse )
					vts[3] = point_add( pvts3 , dw )
					pvts1 = vts[3]
					pvts2 = vts[2]
					pvts0 = pvts3
					dvec_l2 = vector_add( dvec_l2 , dforce )
					dvec_l2.length = dvec_l.length
					pvts3 = point_add( pvts3 , dvec_l2 )
				end
			elsif div == divs
				if @ftype == "Rectanguler"
					vts[0] = pvts1
					vts[1] = pvts2
					vts[2] = point_add( pvts3 , dw.reverse )
					vts[3] = point_add( pvts3 , dw )
				else
					vts[0] = pvts1
					vts[1] = pvts2
					vts[2] = pvts3
				end
			else
				if @ftype == "Arch"
					dw = vector_scale( vec_w , Math.sqrt( 1.0 - div.to_f / divs.to_f ) )
				elsif @ftype == "Leaf"
					fdy = ( 1.0 - div.to_f / divs.to_f * 2.0 ).abs ** 0.5
					dw = vector_scale( vec_w , Math.sqrt( 1.to_f - fdy ) )
				elsif @ftype == "Rectanguler"
					dw = vec_w
				else
					dw = vector_scale( vec_w , ( 1.0 - div.to_f / divs.to_f ) )
				end
					vts[0] = pvts1
					vts[1] = pvts2
					vts[2] = point_add( pvts3 , dw.reverse )
					vts[3] = point_add( pvts3 , dw )
					pvts1 = vts[3]
					pvts2 = vts[2]
					pvts0 = pvts3
					dvec_l2 = vector_add( dvec_l2 , dforce )
					dvec_l2.length = dvec_l.length
					pvts3 = point_add( pvts3 , dvec_l2 )
			end
			pmesh.add_polygon vts
		}
		end
	end
	def s_to_l( tstr1 )
		if tstr1
			tstr = tstr1.to_s.gsub(/\~ /,"")
			return 0 if tstr.to_f == 0
			#if tstr1[@delim]
			#	if tstr["\/"]
			#	else
			#		tstr = tstr1.gsub(/[ \t\r\n\f\v]/,"")
			#	end
			#end
			#tstr = tstr1 if tstr == nil
			if tstr.to_l == 0
				unit = ""
				if tstr["\""]#inch
					ans = tstr.gsub("\"","").to_f.inch
				elsif tstr["'"]#feet
					ans = tstr.gsub("'","").to_f.feet
				elsif tstr["mm"]#mm
					ans = tstr.gsub("mm","").to_f.mm
				elsif tstr["cm"]
					ans = tstr.gsub("cm","").to_f.cm
				elsif tstr["m"]
					ans = tstr.gsub("m","").to_f.m
				else
					if 0.to_l.to_s["\""]
						ans = tstr.to_f.inch
					elsif 0.to_l.to_s["'"]
						ans = tstr.to_f.feet
					elsif 0.to_l.to_s["mm"]
						ans = tstr.to_f.mm
					elsif 0.to_l.to_s["cm"]
						ans = tstr.to_f.cm
					elsif 0.to_l.to_s["m"]
						ans = tstr.to_f.m
					end
				end
				return ans
			else
				return tstr.to_l
			end
		else
			return 0
		end
	end

	def s_to_vec( xyz )
		splt = xyz.split("&&")
		if splt.size > 2
			return Geom::Vector3d.new( s_to_l(splt[0]) , s_to_l(splt[1]) , s_to_l(splt[2]) )
		elsif splt.size > 1
			return Geom::Vector3d.new( s_to_l(plt[0]) , s_to_l(splt[1]), 0 )
		else
			return Geom::Vector3d.new( 0 , 0 , s_to_l(xyz) )
		end
	end
	def pointXYZ( x , y , z)
		Geom::Point3d.new( x, y ,z )
	end
	def vectorXYZ( x , y , z)
		Geom::Vector3d.new( x, y ,z )
	end
	def point_add( vec1 , vec2 )
		Geom::Point3d.new( vec1.x.to_f + vec2.x.to_f , vec1.y.to_f + vec2.y.to_f , vec1.z.to_f + vec2.z.to_f )
	end

	def vector_add( vec1 , vec2 )
		Geom::Vector3d.new( vec1.x.to_f + vec2.x.to_f , vec1.y.to_f + vec2.y.to_f , vec1.z.to_f + vec2.z.to_f )
	end

	def vector_subtract( vec1 , vec2 )
		Geom::Vector3d.new( vec1.x.to_f - vec2.x.to_f , vec1.y.to_f - vec2.y.to_f , vec1.z.to_f - vec2.z.to_f )
	end

	def vector_scale( vec1 , tf )
		Geom::Vector3d.new( vec1.x.to_f * tf.to_f , vec1.y.to_f * tf.to_f , vec1.z.to_f * tf.to_f )
	end

end##of class
def test_furmesh_by_mat()
	model = Sketchup.active_model
	ss = model.selection
	ents = model.entities
	if ss.empty? 
	  UI.messagebox("No selection.")
	  return nil
	end
	ret_furmesh = []
	fgents = Sketchup.active_model.entities
	oocnt = 0

	fur = FUR_EN.new ####create new FUR_EN class
	ss.each{|face|
		mat = face.material
		if fur.get_furmesh_by_mat( face , mat , ret_furmesh ) != nil ###get furmesh array::ret_furmesh = [ polymesh , uv ]
			Sketchup.set_status_text "create mesh"
			ret_furmesh.each{|mesh , uv|
				if mesh != nil
					tgp = fgents.add_group
					tgents = tgp.entities
					if @ftype == "Box"
						tgents.fill_from_mesh( mesh , false ,0 )
					else
						tgents.fill_from_mesh( mesh , false ,12 )
					end
					tgp.material = mat
					oocnt += mesh.count_polygons
					Sketchup.set_status_text "Making #{oocnt} polygons"
				end
			}
		end
	}
end

## add a menu
if( not file_loaded?( File.basename(__FILE__) ) )
	fur = FUR_EN.new
	
	mainmenu = "fur_en"
	menuitem = "fur_en(WebDialog)"
	menuitem_mac = "fur_en(InputBox)"
	UI.add_context_menu_handler do |menu|
		menu.add_separator
		mm = menu.add_submenu( mainmenu )
			mm.add_item( menuitem ) { fur.fur_webdialog( true  ) }
			mm.add_item( menuitem_mac ) { fur.fur_inputbox( true  ) }
	end
	mm = UI.menu("Plugins").add_submenu( mainmenu )
		mm.add_item( menuitem ) { fur.fur_webdialog( true  ) }
		mm.add_item( menuitem_mac ) { fur.fur_inputbox( true  ) }
end

file_loaded(File.basename(__FILE__))
